xtrabackup does not support "--loose-" options

Bug #664128 reported by Partha Dutta on 2010-10-20
6
This bug affects 1 person
Affects Status Importance Assigned to Milestone
Percona XtraBackup moved to https://jira.percona.com/projects/PXB
Fix Released
Low
Alexey Kopytov
2.0
Won't Fix
Undecided
Unassigned
2.1
Won't Fix
Undecided
Unassigned
2.2
Fix Released
Low
Alexey Kopytov

Bug Description

Options such as loose-innodb_read_io_threads are not properly parsed when running xtrabackup, so backups fail. "loose" options should be supported.

Related branches

Percona (percona-team) on 2010-11-25
Changed in percona-xtrabackup:
status: New → Confirmed
importance: Undecided → Low
assignee: nobody → Alexey Kopytov (akopytov)
milestone: none → 1.6
Changed in percona-xtrabackup:
status: Confirmed → New
assignee: Alexey Kopytov (akopytov) → Valentine Gostev (core-longbow)
Valentine Gostev (longbow) wrote :

Partha,

could you please provide more details on use case you have tried? Or what do you mean by not properly parsed?

I have tried putting this option both to xtrabackup's args and to mysql config file - have not met any troubles.

with xtrabackup 1.5:

root@dev302:~# xtrabackup --backup --target-dir=/root/backup/bbb --loose-innodb_read_io_threads
xtrabackup Ver 1.5 Rev 203 for 5.1.53 unknown-linux-gnu (x86_64)
xtrabackup: uses posix_fadvise().
xtrabackup: cd to /var/lib/mysql
xtrabackup: Target instance is assumed as followings.
xtrabackup: innodb_data_home_dir = ./
xtrabackup: innodb_data_file_path = ibdata1:10M:autoextend
xtrabackup: innodb_log_group_home_dir = ./
xtrabackup: innodb_log_files_in_group = 2
xtrabackup: innodb_log_file_size = 5242880
110221 23:04:11 InnoDB: Warning: allocated tablespace 10, old maximum was 9
>> log scanned up to (45356)
[01] Copying ./ibdata1
     to /root/backup/bbb/ibdata1
[01] ...done
[01] Copying ./test/t1.ibd
     to /root/backup/bbb/test/t1.ibd
[01] ...done
xtrabackup: The latest check point (for incremental): '45356'
>> log scanned up to (45356)
xtrabackup: Stopping log copying thread..
xtrabackup: Transaction log of lsn (45356) to (45356) was copied.
root@dev302:~#

Changed in percona-xtrabackup:
milestone: 1.6 → none
status: New → Incomplete
Partha Dutta (pdutta) wrote :
Download full text (4.9 KiB)

Sorry for delay, here is some evidence:

[pdutta] ac4-devmysqldb-001 /home/y/var/mysql/backups $ sudo -u mysql /home/y/bin64/xtrabackup --backup --target-dir=/home/y
/var/mysql/backups
Password:
/home/y/bin64/xtrabackup version 1.6.5 for Percona Server 5.1.58 unknown-linux-gnu (x86_64) (revision id: undefined)
xtrabackup: uses posix_fadvise().
xtrabackup: cd to /home/y/var/mysql/data
xtrabackup: Target instance is assumed as followings.
xtrabackup: innodb_data_home_dir = ./
xtrabackup: innodb_data_file_path = ibdata1:10M:autoextend
xtrabackup: innodb_log_group_home_dir = ./
xtrabackup: innodb_log_files_in_group = 2
xtrabackup: innodb_log_file_size = 5242880
120329 14:13:44 InnoDB: Log file ./ib_logfile0 did not exist: new to be created
InnoDB: Setting log file ./ib_logfile0 size to 5 MB
InnoDB: Database physically writes the file full: wait...
120329 14:13:44 InnoDB: Log file ./ib_logfile1 did not exist: new to be created
InnoDB: Setting log file ./ib_logfile1 size to 5 MB
InnoDB: Database physically writes the file full: wait...
xtrabackup: Something wrong with source files...

and a grep of the /etc/my.cnf:

[pdutta] ac4-devmysqldb-001 /home/y/var/mysql/backups $ grep loose /etc/my.cnf
loose-innodb_use_sys_malloc
loose-innodb_log_buffer_size = 8M
loose-innodb_old_blocks_pct = 37
loose-innodb_mirrored_log_groups = 1
loose-innodb_max_dirty_pages_pct = 90
loose-innodb_rollback_on_timeout = off
loose-innodb_read_ahead_threshold = 56
# loose-innodb_locks_unsafe_for_binlog
loose-innodb_file_per_table
loose-innodb_additional_mem_pool_size = 8M
loose-innodb_stats_on_metadata = on
loose-innodb_log_group_home_dir = /home/y/var/mysql/iblog
loose-innodb_flush_log_at_trx_commit = 1
loose-innodb_doublewrite
loose-innodb_thread_concurrency = 0
loose-innodb_stats_sample_pages = 8
loose-innodb_io_capacity = 200
loose-innodb_table_locks = on
loose-innodb_thread_sleep_delay = 10000
loose-innodb_open_files = 300
loose-innodb_autoinc_lock_mode = 1
loose-innodb_concurrency_tickets = 500
loose-innodb_file_format = Barracuda
loose-innodb_flush_method = O_DIRECT
loose-innodb_read_io_threads = 4
loose-innodb_old_blocks_time = 0
loose-innodb_data_file_path = ibdata1:256M:autoextend
loose-innodb_force_recovery = 0
loose-innodb_sync_spin_loops = 20
loose-innodb_checksums
loose-innodb_stats_method = nulls_equal
loose-innodb_change_buffering = inserts
loose-innodb_max_purge_lag = 0
loose-innodb_log_files_in_group = 2
loose-innodb_buffer_pool_size = 128M
loose-innodb_lock_wait_timeout = 50
loose-innodb_commit_concurrency = 0
loose-innodb_data_home_dir = /home/y/var/mysql/ibdata
loose-innodb_replication_delay = 0
loose-innodb_adaptive_hash_index = on
loose-innodb_file_format_check = on
loose-innodb_strict_mode = off
# loose-innodb_adaptive_flushing
loose-innodb_support_xa = on
loose-innodb_spin_wait_delay = 6
loose-innodb_write_io_threads = 4
loose-innodb_autoextend_increment = 8
loose-innodb_fast_shutdown = 1
loose-innodb_log_file_size = 128M
loose-innodb_flush_neighbor_pages = 1
loose-innodb_log_block_size = 512
# loose-innodb_doublewrite_file
loose-innodb_adaptive_checkpoint = estimate
loose-innodb_extra_rsegments = 0
loose-innodb_checkpoint_age_target = 0
...

Read more...

Stewart Smith (stewart) on 2012-09-04
Changed in percona-xtrabackup:
assignee: Valentine Gostev (longbow) → nobody
Changed in percona-xtrabackup:
status: Incomplete → New

Laurynas, I wonder now too if we need to make it aware of the new
options modifiers as well?

On 9/3/2012 9:20 PM, Laurynas Biveinis wrote:
> ** Changed in: percona-xtrabackup
> Status: Incomplete => New
>

--
George O. Lorch III
Software Engineer, Percona Inc.
+1-888-401-3401 x542 US/Arizona (GMT -7)
skype: george.ormond.lorch.iii

George, that's a good question, we should discuss this.

Download full text (6.4 KiB)

Changed innodb_log_file_size = 512M to loose-innodb_log_file_size = 512M

 sudo innobackupex /tmp

InnoDB Backup Utility v1.5.1-xtrabackup; Copyright 2003, 2009 Innobase Oy
and Percona Inc 2009-2012. All Rights Reserved.

This software is published under
the GNU GENERAL PUBLIC LICENSE Version 2, June 1991.

120926 17:45:33 innobackupex: Starting mysql with options: --unbuffered --
120926 17:45:33 innobackupex: Connected to database with mysql child process (pid=3355)
120926 17:45:39 innobackupex: Connection to database server closed
IMPORTANT: Please check that the backup run completes successfully.
           At the end of a successful backup run innobackupex
           prints "completed OK!".

innobackupex: Using mysql Ver 14.14 Distrib 5.5.27, for Linux (x86_64) using readline 5.1
innobackupex: Using mysql server version Copyright (c) 2000, 2011, Oracle and/or its affiliates. All rights reserved.

innobackupex: Created backup directory /tmp/2012-09-26_17-45-39
120926 17:45:39 innobackupex: Starting mysql with options: --unbuffered --
120926 17:45:39 innobackupex: Connected to database with mysql child process (pid=3382)
120926 17:45:41 innobackupex: Connection to database server closed

120926 17:45:41 innobackupex: Starting ibbackup with command: xtrabackup_55 --defaults-group="mysqld" --backup --suspend-at-end --target-dir=/tmp/2012-09-26_17-45-39
innobackupex: Waiting for ibbackup (pid=3389) to suspend
innobackupex: Suspend file '/tmp/2012-09-26_17-45-39/xtrabackup_suspended'

xtrabackup_55 version 2.0.2 for Percona Server 5.5.16 Linux (x86_64) (revision id: 461)
xtrabackup: uses posix_fadvise().
xtrabackup: cd to /var/lib/mysql
xtrabackup: Target instance is assumed as followings.
xtrabackup: innodb_data_home_dir = ./
xtrabackup: innodb_data_file_path = ibdata1:10M:autoextend
xtrabackup: innodb_log_group_home_dir = ./
xtrabackup: innodb_log_files_in_group = 2
xtrabackup: innodb_log_file_size = 5242880
120926 17:45:41 InnoDB: Using Linux native AIO
120926 17:45:41 InnoDB: Warning: allocated tablespace 10, old maximum was 9
InnoDB: Error: log file ./ib_logfile0 is of different size 0 536870912 bytes
InnoDB: than specified in the .cnf file 0 5242880 bytes!
innobackupex: Error: ibbackup child process has died at /usr/bin/innobackupex line 374.

======================================================================================
Reverted that change back and now it worked

raghu archie:~ [92:2]% sudo innobackupex /tmp

InnoDB Backup Utility v1.5.1-xtrabackup; Copyright 2003, 2009 Innobase Oy
and Percona Inc 2009-2012. All Rights Reserved.

This software is published under
the GNU GENERAL PUBLIC LICENSE Version 2, June 1991.

120926 17:47:03 innobackupex: Starting mysql with options: --unbuffered --
120926 17:47:03 innobackupex: Connected to database with mysql child process (pid=3406)
120926 17:47:09 innobackupex: Connection to database server closed
IMPORTANT: Please check that the backup run completes successfully.
           At the end of a successful backup run innobackupex
           prints "completed OK!".

innobackupex: Using mysql Ver 14.14 Distrib 5.5.27, for Linux (x86_6...

Read more...

Changed in percona-xtrabackup:
status: New → Confirmed
Stewart Smith (stewart) on 2012-12-10
Changed in percona-xtrabackup:
status: Confirmed → Triaged
Philip Stoev (philip-stoev-f) wrote :

This bug presents an obstacle when texting xtrabackup with Galera in MTR. MTR uses "loose-innodb_log_file_size" by default and consequently Galera SST with xtrabackup fail.

Percona now uses JIRA for bug reports so this bug report is migrated to: https://jira.percona.com/browse/PXB-74

To post a comment you must log in.
This report contains Public information  Edit
Everyone can see this information.

Other bug subscribers